#!/usr/bin/env python3

import subprocess
import sys
import time
import argparse
import os

THREADS = 10
RESULT_CNT = 1000

parser = argparse.ArgumentParser()
parser.add_argument('--result-file', type=str)
opt = parser.parse_known_args()[0]

open(opt.result_file, 'a')

log_prefix = os.environ.get('LOGDIR', '')
if log_prefix:
    log_prefix = log_prefix + '/'

procs = [ subprocess.Popen([sys.executable, '-u', 'solve.py', *sys.argv[1:]], stdout=open('%stask%d' % (log_prefix,i), 'a'), stderr=subprocess.STDOUT) for i in range(THREADS) ]

try:
    while sum(1 for _ in open(opt.result_file, 'r')) < RESULT_CNT:
        time.sleep(5)
except KeyboardInterrupt:
    pass

for proc in procs:
    proc.kill()
for proc in procs:
    proc.wait()
